• [LeetCode] Next Greater Element II


    Given a circular array (the next element of the last element is the first element of the array), print the Next Greater Number for every element. The Next Greater Number of a number x is the first greater number to its traversing-order next in the array, which means you could search circularly to find its next greater number. If it doesn't exist, output -1 for this number.

    Example 1:

    Input: [1,2,1]
    Output: [2,-1,2]
    Explanation: The first 1's next greater number is 2; 
    The number 2 can't find next greater number;
    The second 1's next greater number needs to search circularly, which is also 2.

    Note: The length of given array won't exceed 10000.

    找出一个元素后面大于其值的第一个元素。数组是一个循环数组。

    将每个元素的索引放入stack中进行比较,并且因为是循环数组,所以要循环两次该数组。

    class Solution {
    public:
        vector<int> nextGreaterElements(vector<int>& nums) {
            if (nums.empty())
                return {};
            int n = nums.size();
            vector<int> res(n, -1);
            stack<int> stk;
            for (int i = 0; i < 2 * n; ++i)
            {
                int num = nums[i % n];
                while (!stk.empty() && nums[stk.top()] < num)
                {
                    res[stk.top()] = num;
                    stk.pop();
                }
                if (i < n)
                    stk.push(i);
            }
            return res;
        }
    };
  • 相关阅读:
    Codeforces Round #401 (Div. 2)【A,B,C,D】
    HDU2874【LCA(模板)】
    ZOJ2898【折半搜索】
    zoj2901【DP·二进制优化】
    萌新笔记之鸽巢原理及其应用
    codeforces 547B【单调栈】
    Codeforces631C【栈维护+瞎搞】
    每天一节组合数学
    HDU 1506【单调栈】
    HDU 3410【单调栈】
  • 原文地址:https://www.cnblogs.com/immjc/p/9131724.html
Copyright © 2020-2023  润新知